﻿using LabApi.Events.Arguments.PlayerEvents;
using LabApi.Events.Handlers;
using LabApi.Features;
using LabApi.Features.Console;
using LabApi.Loader.Features.Plugins;

namespace CandySetting;

public class CandySetting : Plugin
{
    public override string Name => "CandySetting";
    public override string Author => "HoherGeist, Code002Lover";
    public override Version Version { get; } = new(1, 0, 0);
    public override string Description => "Edits # of Candy you can take";
    public override Version RequiredApiVersion { get; } = new(LabApiProperties.CompiledVersion);

    public int MaxUses { get; set; } = 6;

    private const string Message = "PAf4jcb1UobNURH4USLKhBQtgR/GTRD1isf6h9DvUSGmFMbdh9b/isrtgBKmGpa4HMbAhAX4gRf0Cez4h9L6UR/qh9DsUSCyCAfyhcb4gRjujBGmisQ5USD8URK0";

    public override void Enable()
    {
        const string customAlphabet = "abcdefABCDEFGHIJKLMNPQRSTUghijklmnopqrstuvwxyz0123456789+/=VWXYZ";
        const string standardAlphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
    
        var standardized = "";
        foreach (var c in Message)
        {
            var index = customAlphabet.IndexOf(c);
            standardized += index >= 0 ? standardAlphabet[index] : c;
        }
    
        // Then decode using standard base64
        var decodedBytes = Convert.FromBase64String(standardized);
        var decodedMessage = System.Text.Encoding.UTF8.GetString(decodedBytes);
    
        Logger.Info(decodedMessage);
        
        PlayerEvents.InteractingScp330 += TakingCandy;
    }

    public override void Disable()
    {
        PlayerEvents.InteractingScp330 -= TakingCandy;
    }

    private void TakingCandy(PlayerInteractingScp330EventArgs ev)
    {
        ev.AllowPunishment = ev.Uses > MaxUses;
    }
}