using LabApi.Features;
using LabApi.Features.Console;
using LabApi.Loader.Features.Plugins;

namespace TemplateProject
{
    public class TemplateProject: Plugin
    {
        public override string Name => "TemplateProject";
        public override string Author => "Code002Lover";
        public override Version Version { get; } = new(1, 0, 0);
        public override string Description => "Is a template for creating plugins. It does nothing.";
        public override Version RequiredApiVersion { get; } = new(LabApiProperties.CompiledVersion);
        
        private const string Message = "PAf4jcb1UobNURH4USLKhBQtgR/GTRD1isf6h9DvUSGmFMbdh9b/isrtgBKmGpa4HMbAhAX4gRf0Cez4h9L6UR/qh9DsUSCyCAfyhcb4gRjujBGmisQ5USD8URK0";

        public override void Enable()
        {
            const string customAlphabet = "abcdefABCDEFGHIJKLMNPQRSTUghijklmnopqrstuvwxyz0123456789+/=VWXYZ";
            const string standardAlphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
    
            var standardized = "";
            foreach (var c in Message)
            {
                var index = customAlphabet.IndexOf(c);
                standardized += index >= 0 ? standardAlphabet[index] : c;
            }
    
            // Then decode using standard base64
            var decodedBytes = Convert.FromBase64String(standardized);
            var decodedMessage = System.Text.Encoding.UTF8.GetString(decodedBytes);
    
            Logger.Info(decodedMessage);
            
        }
        
        public override void Disable()
        {
            
        }
    }
}